/*global $ noText yesText*/
var baseButton = $("<button/>")
        .addClass("col-xs-5 button btn button-yellow")
        .attr("data-dismiss", "modal");
var noButton = $(baseButton).clone()
        .text(noText).attr("id","no-button")
        .attr("data-dismiss", "modal").attr("data-user-response", "no");
var yesButton = $(baseButton).clone()
        .text(yesText)
        .attr("id", "yes-button")
        .addClass("pull-right").attr("data-user-response", "yes");

var submitButton = $(baseButton).clone()
    .text(submitText)
    .attr("id", "yes-button")
    .addClass("pull-right").attr("data-user-response", "yes");

var cancelButton = $(baseButton).clone()
    .text(cancelText).attr("id","no-button")
    .attr("data-dismiss", "modal").attr("data-user-response", "no");

function verifyModal(settings) {
    var title = settings.title || "";
    var body = settings.body || "";
    var onYes = settings.onYes;
    var onNo = settings.onNo || function() {};
    var modal = $("#status-modal");
    var modalTitle = $("#status-modal-title");
    var modalBody = $("#status-modal-body");
    var modalFooter = $("#status-modal").find(".modal-footer").first().find(".content-row").first();
    var origFooter = $(modalFooter).clone();
    var yes = $(yesButton).clone();
    var no = $(noButton).clone();
    var buttons = $("<span/>").append($(no)).append($(yes));


    $(modalTitle).html('');
    $(modalBody).html('');
    $(modalFooter).html('');

    $(modalTitle).append(title);
    $(modalBody).append(body);

    $(modalFooter).append($(buttons));

    $(yes).on('click', function() {
        onYes();
    });
    $(no).on('click', function() {onNo();});

    $(modal).on('hidden.bs.modal.footer', function() {
        $(modal).off('hidden.bs.modal.footer');
        $(modalFooter).html(origFooter.html());
    });

    if($(modal).is(':visible')) {
      $(modal).one('hidden.bs.modal', function()
      {
          $(modal).modal(settings);
      });
    } else {
      $(modal).modal(settings);
    }

};

function showLoading(text, body){
    text = text || "";
    body = body || "";
    $('#loading-indicator-text').html(text);
    $("#loading-indicator").append(body);
    $('#loading-indicator').show();


}

function hideLoading() {

    $('#loading-indicator-text').html('');
    $("#loading-indicator").children("img").first().nextAll().remove();
    if ($("#loading-indicator").is(":visible")){
        $('#loading-indicator').hide();
    }

}


function displayModal(settings) {
    var footer = $(settings.id).find(".modal-footer").first().find(".content-row").first();
    var modal = $(settings.id);
    var modalBody = $(settings.bodyID);
    var modalTitle = $(settings.titleID);
    var title = settings.title || "";
    var body = settings.body|| "";
    var origfooter;

    $(modalBody).text(body);
    $(modalTitle).text(title);

     if (settings.footer) {
        origfooter = $(footer).clone();
        $(footer).html('');
        $(footer).append(settings.footer);
        $(modal).on("hidden.bs.modal.DSMF", function() {
            $(modal).off("hidden.bs.modal.DSMF");
            $(footer).html(origfooter.html());
            return true;
        });
     }

    $(modal).on("shown.bs.modal.DSM", function(e){
        $(modal).off("shown.bs.modal.DSM");
        if (settings.onShow) {
            var val = settings.onShow(e);
            if (val === undefined) {
                return true;
            } else {
                return val;
            }

        } else {
            return true;
        }
    });

    $(modal).on("hidden.bs.modal.DSMC", function(e) {
        $(modal).off("hidden.bs.modal.DSMC");
        if (settings.onClose) {
            settings.onClose(e);
        }
    });

    if($(modal).is(':visible')) {
      $(modal).one('hidden.bs.modal', function()
      {
          $(modal).modal(settings);
      });
    } else {
      $(modal).modal(settings);
    }


}
function displayStatusModal(settings) {



    settings.id = "#status-modal";
    settings.bodyID = "#status-modal-body";
    settings.titleID = "#status-modal-title";
    displayModal(settings);


}
